//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include "Unit1.h"
#include "LnAlgebr.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#pragma link "Grids"
const int CellCount = 10;   //  ,   
const int SizeCell = 20;    //   
TFrmSolveSyst *FrmSolveSyst;
//---------------------------------------------------------------------------
__fastcall TFrmSolveSyst::TFrmSolveSyst(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFrmSolveSyst::EdOrderChange(TObject *Sender)
{
  int n = UpDnOrder->Position;  // 
  int CountCR = n + 1;
  StGrMatrix->ColCount = CountCR;   //    
  StGrMatrix->RowCount = CountCR;   //  
  StGrRightPart->RowCount = CountCR;//     
  StGrInversMatrix->ColCount = CountCR;//.  .  
  StGrInversMatrix->RowCount = CountCR;//.  .  
  StGrSolve->RowCount = CountCR;       //.  .  
  int Size = (SizeCell + 1)* CountCR + 5;//  
  int Size10 = SizeCell*11+17;
  int Sizeww = (SizeCell+11)*CountCR+5;
  int Sizeww10 = SizeCell*11+126;
  if(n <= CellCount){
    StGrMatrix->Height = Size;
    StGrMatrix->Width = Sizeww;
    StGrRightPart->Height = Size;
    StGrInversMatrix->Height = Size;
    StGrInversMatrix->Width = Sizeww;
    StGrSolve->Height = Size;
    StGrRightPart->Width =  (SizeCell+10) * 2 + 27;// . . 
    StGrSolve->Width = (SizeCell+10) * 2 + 27;     // . 
  }
  else{
    StGrMatrix->Height = Size10;
    StGrMatrix->Width = Sizeww10;
    StGrRightPart->Height = Size10;
    StGrInversMatrix->Height = Size10;
    StGrInversMatrix->Width = Sizeww10;
    StGrSolve->Height = Size10;
    StGrRightPart->Width =  (SizeCell+10) * 2+44;   // . . 
    StGrSolve->Width = (SizeCell+10) * 2+44;      // . 
  }
//     
  for(int i = 1; i <= n; i++){
    AnsiString Numb = IntToStr(i);  //  
    StGrMatrix->Cells[0][i] = Numb;
    StGrMatrix->Cells[i][0] = Numb;
    StGrInversMatrix->Cells[0][i] = Numb;
    StGrInversMatrix->Cells[i][0] = Numb;
    StGrRightPart->Cells[0][i] = Numb;
    StGrSolve->Cells[0][i] = Numb;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFrmSolveSyst::FormCreate(TObject *Sender)
{
EdOrderChange(Sender);//   
//    
StGrMatrix->DefaultColWidth=SizeCell+10;
StGrMatrix->DefaultRowHeight=SizeCell;
//     
StGrRightPart->DefaultColWidth=SizeCell+20;
StGrRightPart->DefaultRowHeight=SizeCell;
//     
StGrInversMatrix->DefaultColWidth=SizeCell+10;
StGrInversMatrix->DefaultRowHeight=SizeCell;
//     
StGrSolve->DefaultColWidth=SizeCell+20;
StGrSolve->DefaultRowHeight=SizeCell;
}
//---------------------------------------------------------------------------
void __fastcall TFrmSolveSyst::BtnSolveClick(TObject *Sender)
{
  int n = UpDnOrder->Position;// 
  int i, j;
//        
  SystemEq *Syst =  new SystemEq(n);
//      
  for(i = 1; i <= n; i++){
    for(j = 1; j <= n; j++){
    // 
      try{
        Syst->ElemM(i, j) = StrToFloat(StGrMatrix->Cells[j][i]);
      }
      catch(EConvertError&){
        AnsiString ErrorMess = "   (" + IntToStr(i);
        ErrorMess += ", " + IntToStr(j) + ")  ";
        Application->MessageBox(ErrorMess.c_str(), " ", MB_OK);
        StGrMatrix->SetFocus();
        return;
      }
    }
    //  
    try{//    
      Syst->ElemV(i) = StrToFloat(StGrRightPart->Cells[1][i]);
    }
    catch(EConvertError&){//     
//    
      AnsiString ErrorMess = "   " + IntToStr(i);
      ErrorMess += "   ";
//     
      Application->MessageBox(ErrorMess.c_str(), " ", MB_OK);
      StGrRightPart->SetFocus();
      return;//  
    }
  }
  Matrix InvM = ~(*Syst);//  
  Vector Solve = Syst->SolveSystem();//
//   
  for(int i = 1; i <= n; i++){
    // 
    StGrSolve->Cells[1][i] = FloatToStrF(Solve.ElemV(i), ffFixed, 5, 2);
    for(int j = 1; j <= n; j++)
      //  
      StGrInversMatrix->Cells[j][i]=FloatToStrF(InvM.ElemM(i, j), ffFixed, 5, 2);
  }
}
//---------------------------------------------------------------------------